// Output generated from file: C:/Users/Graeme/Fragmentarium/Examples/Historical 3D Fractals/QuaternionCubic4D.frag
// Created: Tue Aug 29 03:03:51 2017
#info 4D Quaternion Julia Distance Estimator
#include "DE-Raytracer.frag"
#group 4D Quaternion Cubic4D

// The DE implementation here is based on the implementation by Subblue:
//  http://www.subblue.com/blog/2009/9/20/quaternion_julia
// which in turn is based on a CG shader by Keenan Crane.
// twist from Darkbeams M3D
// coded by mclarekin for sabine


// Number of fractal iterations.
uniform int Iterations;  slider[0,16,100]
// Breakout distance
uniform float Threshold; slider[0,10,100]


uniform float initialW; slider[-2,0,2]
uniform bool AbsX; checkbox[false]
uniform bool AbsY; checkbox[false]
uniform bool AbsZ; checkbox[false]
uniform bool AbsW; checkbox[false]
uniform vec4 preScale; slider[(0,0,0,0),(1,1,1,1),(1,1,10.0,1)]
uniform float X_twist; slider[-2,0,2]
uniform float Y_twist; slider[-2,0,2]
uniform vec4 scale1222; slider[(0,0,0,0),(1,2,2,2),(5,5,5,5)]
uniform vec4 juliaC; slider[(-1,-1,-1,-1),(0,0,0,0),(1,1,1,1)]
uniform vec4 scaleC1111; slider[(0,0,0,0),(1,1,1,1),(5,5,5,5)]


float DE(vec3 pos) {

	vec4 p = vec4(pos, initialW);
	vec4 dp = vec4(1.0,0.0,0.0,0.0);
	vec4 initialC = p;
	vec4 C = initialC * scaleC1111;

	for (int i = 0; i < Iterations; i++) {
		if (AbsX) p.x = abs(p.x);
		if (AbsY) p.y = abs(p.y);
		if (AbsZ) p.z = abs(p.z);
		if (AbsW) p.w = abs(p.w);
		vec4 mul = p * preScale;
		dp *= preScale;
		vec4 oldP = p;

		//dp = 2.0* vec4(p.x*dp.x-dot(p.yzw, dp.yzw), p.x*dp.yzw+dp.x*p.yzw+cross(p.yzw, dp.yzw));
		dp = 2.0* vec4(mul.x*dp.x-dot(mul.yzw, dp.yzw), mul.x*dp.yzw+dp.x*mul.yzw+cross(mul.yzw, dp.yzw));

		p.x = mul.x * p.x - mul.y * p.y - mul.z * p.z - mul.w * p.w + (C.y * X_twist);
		p.y =  oldP.y * oldP.x;
		p.z =  oldP.z * oldP.x;
		p.w =  oldP.w * oldP.x; 

		p *= scale1222;
		p.y += C.x * Y_twist;
		p += C + juliaC;

		float p2 = dot(p,p);
		orbitTrap = min(orbitTrap, abs(vec4(p.xyz,p2)));
		if (p2 > Threshold) break;
	}
	float r = length(p);
	return  0.5 * r * log(r) / length(dp);
}






#preset Default
FOV = 0.4
Eye = 0,-4,0
Target = 0.0096969,-1.96e-05,0.007913
Up = 0.9999971,-0.0024242,0
EquiRectangular = false
AutoFocus = false
FocalPlane = 1
Aperture = 0
Gamma = 2.17595
ToneMapping = 3
Exposure = 0.3261
Brightness = 1
Contrast = 1
Saturation = 1
GaussianWeight = 1
AntiAliasScale = 2
DepthToAlpha = false
ShowDepth = false
DepthMagnitude = 1
Detail = -3.01273
DetailAO = -0.5
FudgeFactor = 1
MaxDistance = 1000
MaxRaySteps = 104
Dither = 0.5
NormalBackStep = 1
AO = 0.529412,0.352941,0,0.7
Specular = 1
SpecularExp = 16
SpecularMax = 10
SpotLight = 1,1,1,0.38043
SpotLightDir = 0.1,0.1
CamLight = 1,1,1,1
CamLightMin = 0
Glow = 1,1,1,0.16667
GlowMax = 20
Fog = 0
HardShadow = 0 NotLocked
ShadowSoft = 2
QualityShadows = false
Reflection = 0 NotLocked
DebugSun = false
BaseColor = 1,1,1
OrbitStrength = 0.8
X = 0.5,0.6,0.6,0.7
Y = 1,0.6,0,0.4
Z = 0.8,0.78,1,0.5
R = 0.4,0.7,1,0.12
BackgroundColor = 1,0.666667,0
GradientBackground = 0.3
CycleColors = false
Cycles = 1.1
EnableFloor = false
FloorNormal = 0,0,0
FloorHeight = 0
FloorColor = 1,1,1
Iterations = 16
Threshold = 10
AbsX = false
AbsY = false
AbsZ = false
AbsW = false
initialW = 0
preScale = 1,1,1,1
X_twist = 0
Y_twist = 0
scale1222 = 1,2,2,2
juliaC = -1,0,0,0
scaleC1111 = 0,0,0,0
#endpreset

